amends "Workflow.pkl"

import "GitHubAction.pkl"

name = "PrintHelloWorld"

// Fake: not implemented yet in generic GitHubAction module...
local class LabelTrigger extends GitHubAction.Trigger {
	name = "label"
	types = new Listing<String> {
		"created"
	}
}

onRaw {
	[Push] = new GitHubAction.Push {
		branches {
			"develop"
		}
	}
	["workflow_dispatch"] = new GitHubAction.WorkflowDispatch {}
}

onListing {
	new GitHubAction.Push {
		branches {
			"main"
		}
	}
	new GitHubAction.WorkflowDispatch {}
	new LabelTrigger {}
}

jobs {
	["print"] = new {
		`runs-on` = GitHubAction.UbuntuLatest
		steps {
			new GitHubAction.RunStep {
				name = "Hello World"
				run = "echo Hello World"
			}
			new GitHubAction.Step {
				name = "date"
			}
			new GitHubAction.RunStep {
				name = "Print date"
				run = "date"
			}
			new GitHubAction.UsesStep {
				name = "Checkout"
				uses = "actions/checkout@v4"
				with = new {
					["ref"] = "develop"
				}
			}
			new GitHubAction.UsesStep {
				name = "Checkout"
				uses = "actions/checkout@v4"
				with = new {
					["ref"] = "develop"
				}
			}
			new GitHubAction.UsesStep {
				name = "Slack"
				id = "Slack"
				`if` = "${{ failure() }}"
				uses = "slackapi/slack-github-action@v1.25.0"
				with = new {
					["payload"] = """
					{
						"blocks": [
							{
								"type": "section",
								"text": {
									"type": "mrkdwn",
									"text": ":alert: Develop is broken!"
								}
							}
						]
					}
					"""
				}
			}
		}
	}
}